Module (Gradle API 2.14)
Date: 2016-06-14

Package: org.gradle.plugins.ide.idea.model

## [Java] Class Module

- org.gradle.plugins.ide.idea.model.Module

- Represents the customizable elements of an iml (via XML hooks everything of the iml is customizable).

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `INHERITED` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `Module (org.gradle.internal.xml.XmlTransformer withXmlActions, PathFactory pathFactory)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `protected Object` | `configure(Path contentPath, Set<Path> sourceFolders, Set<Path> testSourceFolders, Set<Path> generatedSourceFolders, Set<Path> excludeFolders, Boolean inheritOutputDirs, Path outputDir, Path testOutputDir, Set<Dependency> dependencies, String jdkName, String languageLevel)`
    `boolean` | `equals(Object o)`
    `Path` | `getContentPath()` The directory for the content root of the module.
    `protected String` | `getDefaultResourceName()`
    `Set<Dependency>` | `getDependencies()` The dependencies of this module.
    `Set<Path>` | `getExcludeFolders()` The directories to be excluded.
    `Set<Path>` | `getGeneratedSourceFolders()` The directories containing generated the production sources.
    `static String` | `getINHERITED()`
    `boolean` | `getInheritOutputDirs()`
    `String` | `getJdkName()`
    `Path` | `getOutputDir()` The output directory for production classes.
    `Set<Path>` | `getSourceFolders()` The directories containing the production sources.
    `Path` | `getTestOutputDir()` The output directory for test classes.
    `Set<Path>` | `getTestSourceFolders()` The directories containing the test sources.
    `int` | `hashCode()`
    `protected boolean` | `isDependencyOrderEntry(Object orderEntry)`
    `boolean` | `isInheritOutputDirs()` If true, output directories for this module will be located below the output directory for the project; otherwise, outputDir and testOutputDir will take effect.
    `protected void` | `load(groovy.util.Node xml)`
    `void` | `setContentPath(Path contentPath)`
    `void` | `setDependencies(Set<Dependency> dependencies)`
    `void` | `setExcludeFolders(Set<Path> excludeFolders)`
    `void` | `setGeneratedSourceFolders(Set<Path> generatedSourceFolders)`
    `void` | `setInheritOutputDirs(boolean inheritOutputDirs)`
    `void` | `setJdkName(String jdkName)`
    `void` | `setOutputDir(Path outputDir)`
    `void` | `setSourceFolders(Set<Path> sourceFolders)`
    `void` | `setTestOutputDir(Path testOutputDir)`
    `void` | `setTestSourceFolders(Set<Path> testSourceFolders)`
    `protected void` | `store(groovy.util.Node xml)`
    `String` | `toString()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject` | `org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#load(java.io.InputStream), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#store(java.io.OutputStream), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#getXml(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#findFirstChildWithAttributeValue(groovy.util.Node, java.lang.String, java.lang.String, java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#findOrCreateFirstChildNamed(groovy.util.Node, java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#findOrCreateFirstChildWithAttributeValue(groovy.util.Node, java.lang.String, java.lang.String, java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#findFirstChildNamed(groovy.util.Node, java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#transformAction(groovy.lang.Closure), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#load(java.io.File), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#store(java.io.File), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#loadDefaults(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#setProperty(java.lang.String, java.lang.Object), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#getProperty(java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#invokeMethod(java.lang.String, java.lang.Object), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#getMetaClass(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#setMetaClass(groovy.lang.MetaClass), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#wait(long, int), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#wait(long), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#wait(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#equals(java.lang.Object), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#toString(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#hashCode(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#getClass(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#notify(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#notifyAll()`
    `class org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject` | `org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#load(java.io.InputStream), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#load(java.io.File), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#store(java.io.File), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#store(java.io.OutputStream), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#loadDefaults(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#setProperty(java.lang.String, java.lang.Object), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#getProperty(java.lang.String), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#invokeMethod(java.lang.String, java.lang.Object), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#getMetaClass(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#setMetaClass(groovy.lang.MetaClass), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#wait(long, int), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#wait(long), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#wait(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#equals(java.lang.Object), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#toString(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#hashCode(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#getClass(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#notify(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#notifyAll()`

- - ### Field Detail

    - #### public static final String INHERITED

  - ### Constructor Detail

    - #### public Module(org.gradle.internal.xml.XmlTransformer withXmlActions, PathFactory pathFactory)

  - ### Method Detail

    - #### protected Object configure(Path contentPath, Set<Path> sourceFolders, Set<Path> testSourceFolders, Set<Path> generatedSourceFolders, Set<Path> excludeFolders, Boolean inheritOutputDirs, Path outputDir, Path testOutputDir, Set<Dependency> dependencies, String jdkName, String languageLevel)

    - #### @Override public boolean equals(Object o)

    - #### public Path getContentPath()

      The directory for the content root of the module. Defaults to the project directory. If null, the directory containing the output file will be used.

    - #### @Override protected String getDefaultResourceName()

    - #### public Set<Dependency> getDependencies()

      The dependencies of this module. Must not be null.

    - #### public Set<Path> getExcludeFolders()

      The directories to be excluded. Must not be null.

    - #### public Set<Path> getGeneratedSourceFolders()

      The directories containing generated the production sources. Must not be null.

    - #### public static String getINHERITED()

    - #### public boolean getInheritOutputDirs()

    - #### public String getJdkName()

    - #### public Path getOutputDir()

      The output directory for production classes. If `null`, no entry will be created.

    - #### public Set<Path> getSourceFolders()

      The directories containing the production sources. Must not be null.

    - #### public Path getTestOutputDir()

      The output directory for test classes. If `null`, no entry will be created.

    - #### public Set<Path> getTestSourceFolders()

      The directories containing the test sources. Must not be null.

    - #### @Override public int hashCode()

    - #### protected boolean isDependencyOrderEntry(Object orderEntry)

    - #### public boolean isInheritOutputDirs()

      If true, output directories for this module will be located below the output directory for the project; otherwise, outputDir and testOutputDir will take effect.

    - #### @Override protected void load(groovy.util.Node xml)

    - #### public void setContentPath(Path contentPath)

    - #### public void setDependencies(Set<Dependency> dependencies)

    - #### public void setExcludeFolders(Set<Path> excludeFolders)

    - #### public void setGeneratedSourceFolders(Set<Path> generatedSourceFolders)

    - #### public void setInheritOutputDirs(boolean inheritOutputDirs)

    - #### public void setJdkName(String jdkName)

    - #### public void setOutputDir(Path outputDir)

    - #### public void setSourceFolders(Set<Path> sourceFolders)

    - #### public void setTestOutputDir(Path testOutputDir)

    - #### public void setTestSourceFolders(Set<Path> testSourceFolders)

    - #### @Override protected void store(groovy.util.Node xml)

    - #### @Override public String toString()